#ifndef D3DDEVICESUBJECT_H
#define D3DDEVICESUBJECT_H

//--------------------------------------------------------------------------------------
// File: D3DDeviceSubject.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// D3DDevice Observer pattern
// Concrete class for ID3DDeviceSubject interface
//
//--------------------------------------------------------------------------------------

#include <vector>

#include "D3DDeviceObserverPattern.h"

class CD3DDeviceSubject;

//--------------------------------------------------------------------------------------
// CD3DDeviceSubject implements ID3DDeviceSubject interface
//--------------------------------------------------------------------------------------
class CD3DDeviceSubject: public ID3DDeviceSubject
{
protected:
	CD3DDeviceSubject(const CD3DDeviceSubject &);
	const CD3DDeviceSubject & operator=(const CD3DDeviceSubject &);
public:
	CD3DDeviceSubject() { }
	virtual ~CD3DDeviceSubject() { }

	virtual void RegisterObserver(ID3DDeviceObserver * d3dDeviceObserver);
	virtual void RemoveObserver(ID3DDeviceObserver * d3dDeviceObserver);

	virtual HRESULT NotifyCreatedDevice( IDirect3DDevice9* pd3dDevice );
	virtual HRESULT NotifyResetDevice();
	virtual HRESULT NotifyLostDevice();
	virtual HRESULT NotifyDestroyDevice();
protected:
	std::vector<ID3DDeviceObserver *> m_D3DDeviceObserver;
};

#endif // D3DDEVICESUBJECT_H