#ifndef KEYBOARD_H
#define KEYBOARD_H

//--------------------------------------------------------------------------------------
// File: Keyboard.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// Keyboard observer header
// CKeyboard class implements IMsgObserver interface
//
//--------------------------------------------------------------------------------------

#include "MsgObserverPattern.h"

class CKeyboard;

//--------------------------------------------------------------------------------------
// CKeyboard implements IMsgObserver interface
//--------------------------------------------------------------------------------------
class CKeyboard: public IMsgObserver
{
public:
	CKeyboard()
	{
		for (int i = 0; i < 256; ++i)
			m_Keys[i] = false;
	}
	virtual ~CKeyboard() { }

	bool isKey(unsigned char Key) { return m_Keys[Key]; }

	void MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
protected:
	bool m_Keys[256];
};

inline void CKeyboard::MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_KEYDOWN:
		m_Keys[(unsigned char)(wParam)] = true;
		break;
	case WM_KEYUP:
		m_Keys[(unsigned char)(wParam)] = false;
		break;
	}
}

#endif // KEYBOARD_H