#ifndef MSGOBSERVERPATTERN_H
#define MSGOBSERVERPATTERN_H

//--------------------------------------------------------------------------------------
// File: MsgObserverPattern.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// MsgProc Observer pattern
// IMsgSubject and IMsgObserver interfaces
//
//--------------------------------------------------------------------------------------

class IMsgSubject;
class IMsgObserver;

//--------------------------------------------------------------------------------------
// IMsgSubject interface
//--------------------------------------------------------------------------------------
class IMsgSubject
{
public:
	IMsgSubject() { }
	virtual ~IMsgSubject() { }

	virtual void RegisterObserver(IMsgObserver * msgObserver) = 0;
	virtual void RemoveObserver(IMsgObserver * msgObserver) = 0;
	virtual void NotifyObservers(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) = 0;
};

//--------------------------------------------------------------------------------------
// IMsgObserver interface
//--------------------------------------------------------------------------------------
class IMsgObserver
{
public:
	IMsgObserver() { }
	virtual ~IMsgObserver() { }

	virtual void MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) = 0;
};

#endif // MSGOBSERVERPATTERN_H