#ifndef MSGSUBJECT_H
#define MSGSUBJECT_H

//--------------------------------------------------------------------------------------
// File: MsgSubject.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// MsgProc Observer pattern
// Concrete class for IMsgSubject interface
//
//--------------------------------------------------------------------------------------

#include <vector>

#include "MsgObserverPattern.h"

class CMsgSubject;

//--------------------------------------------------------------------------------------
// CMsgSubject implements IMsgSubject interface
//--------------------------------------------------------------------------------------
class CMsgSubject: public IMsgSubject
{
protected:
	CMsgSubject(const CMsgSubject &);
	const CMsgSubject & operator=(const CMsgSubject &);
public:
	CMsgSubject() { }
	virtual ~CMsgSubject() { }

	virtual void RegisterObserver(IMsgObserver * msgObserver);
	virtual void RemoveObserver(IMsgObserver * msgObserver);
	virtual void NotifyObservers(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
protected:
	std::vector<IMsgObserver *> m_MsgObserver;
};

#endif // MSGSUBJECT_H