#ifndef RFWALGEBRAIO_H
#define RFWALGEBRAIO_H

//--------------------------------------------------------------------------------------
// File: RFWAlgebraIO.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// Robot Framework core IO extension header
// CVectorReader and CMatrixReader classes
//
//--------------------------------------------------------------------------------------

#include "RFWCoreIO.h"

namespace RFW
{
	class CVector;
	class CMatrix;
	class CVectorReader;
	class CMatrixReader;
}

namespace RFW
{
	//--------------------------------------------------------------------------------------
	// CVectorReader class reads RFW::CVector
	//--------------------------------------------------------------------------------------
	class CVectorReader
	{
	protected:
		CVectorReader(const CVectorReader &);
		const CVectorReader & operator=(const CVectorReader &);
	public:
		CVectorReader() { }
		virtual ~CVectorReader() { }

		virtual void Read(CEnkiIOStruct & enkiIOStruct, CVector & vec);
	};

	//--------------------------------------------------------------------------------------
	// CMatrixReader class reads RFW::CMatrix
	//--------------------------------------------------------------------------------------
	class CMatrixReader
	{
	protected:
		CMatrixReader(const CMatrixReader &);
		const CMatrixReader & operator=(const CMatrixReader &);
	public:
		CMatrixReader() { }
		virtual ~CMatrixReader() { }

		virtual void Read(CEnkiIOStruct & enkiIOStruct, CMatrix & mat);
	};
}

#endif // RFWALGEBRAIO_H