#ifndef RFWNEURALROBOT_H
#define RFWNEURALROBOT_H

//--------------------------------------------------------------------------------------
// File: RFWNeuralRobot.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// Robot Framework core classes extension header
// CEnkiNeuralRobot class is a wrapper class for Enki::NeuralRobot
//
//--------------------------------------------------------------------------------------

#include "RFWCoreClasses.h"

namespace Enki
{
	class NeuralRobot;
}

namespace RFW
{
	class CEnkiNeuralRobot;
}

namespace RFW
{
	//--------------------------------------------------------------------------------------
	// CEnkiNeuralRobot class implements IEnkiRobot interface
	// WARNING: This class should not be subclassed
	//--------------------------------------------------------------------------------------
	class CEnkiNeuralRobot: public IEnkiRobot
	{
	protected:
		CEnkiNeuralRobot(const CEnkiNeuralRobot &);
		const CEnkiNeuralRobot & operator=(const CEnkiNeuralRobot &);
	public:
		explicit CEnkiNeuralRobot(CEnkiWorld &);
		virtual ~CEnkiNeuralRobot();

		void ClearRobot();

		virtual void Render();

		virtual void Read(CEnkiIOStruct &);

		virtual Enki::NeuralRobot * GetEnkiRobot() { return &m_NeuralRobot; }
	public:
		CVertexBuffer & m_VertexBuffer;
		CEnkiWorld & m_EnkiWorld;
	protected:
		Enki::NeuralRobot m_NeuralRobot;
		IEnkiGraphics * m_EnkiNeuralRobotGraphics;
		IEnkiIO * m_EnkiNeuralRobotIO;
	};
}

#endif // RFWNEURALROBOT_H