#ifndef RFWNEURALROBOTGRAPHICS_H
#define RFWNEURALROBOTGRAPHICS_H

//--------------------------------------------------------------------------------------
// File: RFWNeuralRobotGraphics.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// Robot Framework core graphics extension header
// CEnkiNeuralRobotGraphics class for CEnkiNeuralRobot
//
//--------------------------------------------------------------------------------------

#include "RFWCoreGraphicsClasses.h"

class CVertexBuffer;

namespace RFW
{
	class CEnkiNeuralRobot;
	class CEnkiNeuralRobotGraphics;
}

namespace RFW
{
	//---------------------------------------------------------------------------------------
	// CEnkiNeuralRobotGraphics class implements IEnkiGraphics interface for CEnkiNeuralRobot
	//---------------------------------------------------------------------------------------
	class CEnkiNeuralRobotGraphics: public IEnkiGraphics
	{
	protected:
		CEnkiNeuralRobotGraphics(const CEnkiNeuralRobotGraphics &);
		const CEnkiNeuralRobotGraphics & operator=(const CEnkiNeuralRobotGraphics &);
	public:
		explicit CEnkiNeuralRobotGraphics(CEnkiNeuralRobot & enkiNeuralRobot);
		virtual ~CEnkiNeuralRobotGraphics() { }

		virtual void Render();
	protected:
		virtual void RenderDirection();
		virtual void RenderWheels();
	protected:
		CVertexBuffer & m_VertexBuffer;
		CEnkiNeuralRobot & m_EnkiNeuralRobot;

		CEnkiPhysicalObjectPlotter m_EnkiPhysicalObjectPlotter;
		CEnkiCircularCamPlotter m_EnkiCircularCamPlotter;
		CEnkiIRSensorPlotter m_EnkiIRSensorPlotter;
	};
}

#endif // RFWNEURALROBOTGRAPHICS_H