#ifndef RFWNEURALROBOTIO_H
#define RFWNEURALROBOTIO_H

//--------------------------------------------------------------------------------------
// File: RFWNeuralRobotIO.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// Robot Framework core IO extension header
// CEnkiNeuralRobotIO class for CEnkiNeuralRobot
//
//--------------------------------------------------------------------------------------

#include "RFWCoreIOClasses.h"

namespace RFW
{
	class CEnkiNeuralRobot;
	class CEnkiNeuralRobotIO;
}

namespace RFW
{
	//--------------------------------------------------------------------------------------
	// CEnkiNeuralRobotIO class implements IEnkiIO interface for CEnkiNeuralRobot
	//--------------------------------------------------------------------------------------
	class CEnkiNeuralRobotIO: public IEnkiIO
	{
	protected:
		CEnkiNeuralRobotIO(const CEnkiNeuralRobotIO &);
		const CEnkiNeuralRobotIO & operator=(const CEnkiNeuralRobotIO &);
	public:
		explicit CEnkiNeuralRobotIO(CEnkiNeuralRobot & enkiNeuralRobot):
		  m_EnkiNeuralRobot(enkiNeuralRobot) { }
		virtual ~CEnkiNeuralRobotIO() { }

		virtual void Read(CEnkiIOStruct &);
	protected:
		virtual void ReadSensors(CEnkiIOStruct &);
	protected:
		CEnkiNeuralRobot & m_EnkiNeuralRobot;
		CEnkiPhysicalObjectReader m_EnkiPhysicalObjectReader;
		CEnkiCircularCamReader m_EnkiCircularCamReader;
		CEnkiIRSensorReader m_EnkiIRSensorReader;
	};
}

#endif // RFWNEURALROBOTIO_H