#ifndef TEXTPARSER_H
#define TEXTPARSER_H

//--------------------------------------------------------------------------------------
// File: TextParser.h
// Author: Peter Cerno <petercerno@gmail.com>
//
// Simple class for parsing text
// Contains simple method: int CTextParser::Parse
//
//--------------------------------------------------------------------------------------

#include <sstream>
#include <vector>

//--------------------------------------------------------------------------------------
// CTextParser class
//--------------------------------------------------------------------------------------
template<typename T>
class CTextParser
{
protected:
	CTextParser(const CTextParser<T> &);
	CTextParser & operator=(const CTextParser<T> &);
public:
	CTextParser(): m_Good(true) { }
	int Parse(std::vector<T> & container, std::string text);
	bool Good() { return m_Good; }
	bool IsError() { return !m_Good; }
protected:
	bool m_Good;
};

template<typename T>
int CTextParser<T>::Parse(std::vector<T> & container, std::string text)
{
	std::istringstream Stream(text);
	int Count = 0;
	T   Value = 0;

	m_Good = true;

	if (!Stream)
	{
		m_Good = false;
		return 0;
	}
	while (Stream >> Value)
	{
		container.push_back(Value);
		++Count;
	}
	if (!Stream.eof())
		m_Good = false;
	return Count;
}

#endif // TEXTPARSER_H