function savenetwork(filename, net, mean, std, PCAmatrix)
% Saves network to an xml file
fid = fopen(filename, 'wt');
numLayers = net.numLayers;
[inputDimensions  n] = size(mean);
outputDimensions = net.layers{numLayers}.dimensions;
fprintf(fid, '<network inputDimensions = "%d" outputDimensions = "%d" numLayers = "%d">\n', inputDimensions, outputDimensions, numLayers);
fprintf(fid, '  <mean>\n');
fprintf(fid, '    <vector m = "%d">\n', inputDimensions);
fprintf(fid, '      %.10f\n', mean.');
fprintf(fid, '    </vector>\n');
fprintf(fid, '  </mean>\n');
fprintf(fid, '  <std>\n');
fprintf(fid, '    <vector m = "%d">\n', inputDimensions);
fprintf(fid, '      %.10f\n', std.');
fprintf(fid, '    </vector>\n');
fprintf(fid, '  </std>\n');
fprintf(fid, '  <PCAmatrix>\n');
[m n] = size(PCAmatrix);
fprintf(fid, '    <matrix m = "%d" n = "%d">\n', m, n);
format     = '';
for j = 1:n
    if j == 1
        format = strcat(format, '      %.10f');        
    else
        format = strcat(format, '\t%.10f');
    end
end
format = strcat(format, '\n');
fprintf(fid, format, PCAmatrix.');
fprintf(fid, '    </matrix>\n');
fprintf(fid, '  </PCAmatrix>\n');
fprintf(fid, '  <layers>\n');
for i = 1:numLayers
fprintf(fid, '    <layer index = "%d" dimensions = "%d" transferFcn = "%s" />\n', i, net.layers{i}.dimensions, net.layers{i}.transferFcn);
end
fprintf(fid, '  </layers>\n');
fprintf(fid, '  <weights>\n');
fprintf(fid, '    <inputlayer to = "1">\n');
[m n] = size(net.IW{1});
fprintf(fid, '      <matrix m = "%d" n = "%d">\n', m, n);
format     = '';
for j = 1:n
    if j == 1
        format = strcat(format, '        %.10f');        
    else
        format = strcat(format, '\t%.10f');
    end
end
format = strcat(format, '\n');
fprintf(fid, format, net.IW{1}.');
fprintf(fid, '      </matrix>\n');
fprintf(fid, '    </inputlayer>\n');
for i = 2:numLayers
fprintf(fid, '    <hiddenlayer to = "%d" from = "%d">\n', i, i - 1);
[m n] = size(net.LW{i, i - 1});
fprintf(fid, '      <matrix m = "%d" n = "%d">\n', m, n);
format     = '';
for j = 1:n
    if j == 1
        format = strcat(format, '        %.10f');        
    else
        format = strcat(format, '\t%.10f');
    end
end
format = strcat(format, '\n');
fprintf(fid, format, net.LW{i, i - 1}.');
fprintf(fid, '      </matrix>\n');
fprintf(fid, '    </hiddenlayer>\n');
end
fprintf(fid, '  </weights>\n');
fprintf(fid, '  <biases>\n');
for i = 1:numLayers
fprintf(fid, '    <bias to = "%d">\n', i);
[m n] = size(net.b{i});
fprintf(fid, '      <vector m = "%d">\n', m);
fprintf(fid, '        %.10f\n', net.b{i}.');
fprintf(fid, '      </vector>\n');
fprintf(fid, '    </bias>\n');
end
fprintf(fid, '  </biases>\n');
fprintf(fid, '</network>');
fclose(fid);
end